% Implementar o num_clusters-means com animao
clear; clc; close all;

% Cria conjunto de dados nx2
points = [1 1.5 1.7 2.2 2 2.5 5.5 4.5 5.1 5 5.3 6; 
    1 2 0.9 1.9 1.5 1 5 4 3.6 3 4.2 4 ]';
%points = class5(20);

num_clusters = 5; %number of clusters
max_it = 20; %number of iterations 

num_points = size(points,1); %max 
clusters = zeros(num_clusters,size(points,2)); %intial  coordinates of each cluster
index = zeros(1,num_clusters);

for i = 1:num_clusters   %assign the clusters to the random data points
    index(i) = round(1 + (num_points - 1)*rand); %random number between 1 and 12
    clusters(i,:) = points(index(i),:);
end

cluster_index = zeros(num_points,1); %assign each point to a cluster number ex. 1st points to cluster 4

var_cond = 1;
W = 1;
while W
    % calculate the distance matrix
    dist = zeros(num_points,num_clusters);  %matrix with # clusters points # points
    for i = 1:num_points
        for c = 1:num_clusters
            deltaX = points(i,1)-clusters(c,1);
            deltaY = points(i,2)-clusters(c,2);
            
            dist(i,c) = sqrt(deltaX^2 + deltaY^2);
        end
    end

    old_cluster = cluster_index;
    % find closest cluster_index to point
    for i = 1:num_points
        [~,index] = min(dist(i,:)) %we're not interested of the actual value, but its index 
         cluster_index(i) = index
    end
    
    % visualize the results
    colors = rand(num_clusters,3);
    clf;
    plota(points,cluster_index,colors);
    pause(1);
    plotaCentroide(clusters);
    plota_linhas(points,cluster_index,clusters);
    pause(1);

    new_cluster = cluster_index;
        
    % calculate the new centers
    for i = 1:num_clusters 
        cluster_points = points(cluster_index == i,:); % we group the points with the same index
        clusters(i,:) = sum(cluster_points)/size(cluster_points,1);
    end
    
    %if no change, get out of the loop
    if old_cluster == new_cluster
        W = 0;
    end
    
    % if iterations limit is reached, get out of the loop
    if var_cond > max_it
        W = 0;
    end
        
    % iterations increment
    var_cond = var_cond + 1;
end

cluster_index = new_cluster;
num_it = var_cond;

% Mostra resultados visuais
colors = rand(num_clusters,3);

figure(1);
hold on;
for i = 1: length(points)
    p = plot(points(i,1), points(i,2),'mx','LineWidth',3');
    set(p, 'color', colors(cluster_index(i),:))
end